#include "consumer.h"

void consumer::proc_consumer()
{
	if(reset_n.read()==false)
	{
		// initialize outputs
		ack.write(false);

		data_r=0;
		valid.write(false);
	}
	else
	{
		// test if rising edge
		if(clock.read()==true)
		{
			if (req.read()==true) 				// if data read is requested,
				if (ack.read()==false) {				// and if no ack operation is under way,
					data_r.write(data_s.read());		// acquire data,
					ack.write(true);					// acknowledge it,
					valid.write(true);					// and make it available off the cosumer
				}
				else
					valid.write(false);					// acknowledged request not finished
														// just release valid

			else								// else, no request operation under way
				if (ack.read()==true) {				// if just ack release is missing,
					ack.write(false);					// release it
					valid.write(false);					// and release valid
				}
				else
					; 								// else, nothing is happening, do nothing
		}
		// do nothing at falling edges
	}
}
