#include "producer.h"
#include <stdlib.h>

void producer::proc_producer()
{
	if(reset_n.read()==false)
	{
		// initialize outputs
		req.write(false);
		data_s=0;
	}
	else
	{
		// test if rising edge
		if(clock.read()==true)
		{
			if (ack.read()==false)				// if no acknowledgement operation is under way,
				if (req.read()==false) {		// and if no request operation is under way,
					data_s.write(rand()%256);	// produce new data
					req.write(true);			// and make it available
				}
				else;							// request not acknowledged is under way, wait

			else								// else, acknowledgement operation is under way
				if (req.read()==true)			// if some request operation was under way,
					req.write(false);			// finish this request operation
				else; 							// acknowledgement not finished, wait
		}
		// do nothing at falling edges
	}
}
