#ifndef _producer
#define _producer

#include <systemc.h>

SC_MODULE(producer)
{
	sc_in<bool > clock;
	sc_in<bool > reset_n;

	sc_out<sc_uint<8> > data_s;

	sc_out<bool > req;
	sc_in<bool > ack;

	void proc_producer();

	SC_CTOR(producer)
	{
		SC_METHOD(proc_producer);
		sensitive << reset_n.neg();
		sensitive << clock.pos();
	}
};

#endif
